/* 1099109879*/
/*DROP DATABASE IF EXISTS sct_menu;
CREATE DATABASE sct_menu;
USE sct_menu;
*/
CREATE TABLE trabajador(
	nT VARCHAR(20),
	nombre VARCHAR(50),
	apellidos VARCHAR(50),
	rfc VARCHAR(13),
	direccion TEXT,
	telefono VARCHAR(15),
	correo VARCHAR(100),
	PRIMARY KEY(nT)
)ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE usuario(
	us VARCHAR(20),
	pass VARCHAR(40),
	estado INT(1) DEFAULT 1,
	tipoUs VARCHAR(20),
	nT VARCHAR(20),
	PRIMARY KEY(us),
	FOREIGN KEY(nT) REFERENCES trabajador(nT) ON UPDATE CASCADE
)ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE platillo(
	idP INT AUTO_INCREMENT,
	descripcion TEXT,
	imagen LONGBLOB,
	nomImagen TEXT,
	tipoImagen VARCHAR(10),
	estadoP INT(1) DEFAULT 1,
	PRIMARY KEY(idP)
)ENGINE=InnoDB  DEFAULT CHARSET=utf8;



CREATE TABLE menu(
	fecha  DATE,
	hi TIME,
	hf TIME,
	costo FLOAT,
	descuento FLOAT,
	estado INT(1),
	PRIMARY KEY(fecha)
)ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE menu_detalle(
	fecha DATE,
	idP INT,
	FOREIGN KEY(fecha) REFERENCES menu(fecha) ON UPDATE CASCADE ON DELETE CASCADE,
	FOREIGN KEY(idP) REFERENCES platillo(idP),
	PRIMARY KEY(fecha,idP)	
)ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE apartado(
	fecha DATE,
	idP INT,
	nT VARCHAR(20),
	FOREIGN KEY(fecha) REFERENCES menu_detalle(fecha) ON UPDATE CASCADE ON DELETE CASCADE,
	FOREIGN KEY(idP) REFERENCES menu_detalle(idP) ON UPDATE CASCADE ON DELETE CASCADE,
	FOREIGN KEY(nT) REFERENCES trabajador(nT) ON UPDATE CASCADE,
	PRIMARY KEY (fecha,nT)
	
)ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE configuracion(
	costo FLOAT,
	descuento FLOAT,
	correo TEXT
	
)ENGINE=InnoDB  DEFAULT CHARSET=utf8;


/* datos de inicio */
INSERT trabajador VALUE (2,"admin","admin","","","","");
INSERT usuario VALUE ("admin",SHA1("123456"),1,"Administrador",2);
INSERT trabajador VALUE (1,"Root","Root","","","","");
INSERT usuario VALUE ("root",SHA1("root2014"),1,"Administrador",1);

INSERT INTO `configuracion` (`costo`, `descuento`, `correo`) VALUES ('50', '30', 'jasame_261190@hotmail.com');